geos::noding::IntersectionAdder Class Reference

Computes the intersections between two line segments in SegmentString and adds them to each string. More...

`#include <IntersectionAdder.h>`

Inheritance diagram for geos::noding::IntersectionAdder:

## Public Member Functions

| IntersectionAdder (algorithm::LineIntersector &newLi)
algorithm::LineIntersector & | getLineIntersector ()
const geom::CoordinateXYZM & | getProperIntersectionPoint ()
bool | hasIntersection ()
bool | hasProperIntersection ()
| A proper intersection is an intersection which is interior to at least two line segments.
bool | hasProperInteriorIntersection ()
| A proper interior intersection is a proper intersection which is not contained in the set of boundary nodes set for this SegmentIntersector.
bool | hasInteriorIntersection ()
| An interior intersection is an intersection which is in the interior of some segment.
void | processIntersections (SegmentString *e0, std::size_t segIndex0, SegmentString *e1, std::size_t segIndex1) override
| This method is called by clients of the SegmentIntersector class to process intersections for two segments of the SegmentStrings being intersected.
bool | isDone () const override
| Always process all intersections.

## Static Public Member Functions

static bool | isAdjacentSegments (std::size_t i1, std::size_t i2)

## Public Attributes

int | numIntersections
int | numInteriorIntersections
int | numProperIntersections
int | numTests

## Detailed Description

Computes the intersections between two line segments in SegmentString and adds them to each string.

The SegmentIntersector is passed to a Noder. The NodedSegmentString::addIntersections(algorithm::LineIntersector* li, std::size_t segmentIndex, std::size_t geomIndex) method is called whenever the Noder detects that two SegmentStrings might intersect. This class is an example of the Strategy pattern.

## Member Function Documentation

## getProperIntersectionPoint()

const geom::CoordinateXYZM & geos::noding::IntersectionAdder::getProperIntersectionPoint | ( |  | ) |

inline

Returns
  the proper intersection point, or Coordinate::getNull() if none was found

## hasProperIntersection()

bool geos::noding::IntersectionAdder::hasProperIntersection | ( |  | ) |

inline

A proper intersection is an intersection which is interior to at least two line segments.

Note that a proper intersection is not necessarily in the interior of the entire Geometry, since another edge may have an endpoint equal to the intersection, which according to SFS semantics can result in the point being on the Boundary of the Geometry.

## isDone()

bool geos::noding::IntersectionAdder::isDone | ( |  | ) | const

inline override virtual

Always process all intersections.

Returns
  false always

Reimplemented from geos::noding::SegmentIntersector.

## processIntersections()

void geos::noding::IntersectionAdder::processIntersections | ( | SegmentString * | e0,
|  | std::size_t | segIndex0,
|  | SegmentString * | e1,
|  | std::size_t | segIndex1 )

override virtual

This method is called by clients of the SegmentIntersector class to process intersections for two segments of the SegmentStrings being intersected.

Note that some clients (such as MonotoneChains) may optimize away this call for segment pairs which they have determined do not intersect (e.g. by an disjoint envelope test).

Implements geos::noding::SegmentIntersector.

The documentation for this class was generated from the following file:

- IntersectionAdder.h